/*	Copyright 2007-2009 by Marco Pivetta (ocramius@gmail.com)
    This file is part of StOgame.

    StOgame is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    StOgame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with StOgame.  If not, see <http://www.gnu.org/licenses/>. */
/************************************************************************************************************************************************
//THIS OBJECT IS USED TO GET DATA FROM STOGAME WITHOUT ANY WAY TO INTERACT WITH MOZILLA FIREFOX
//EVERY INTERFACE ALLOWS LIMITED ACTIONS SUCH AS GETTING A PLAYER LIST OR SAVING A SR TO DB
************************************************************************************************************************************************/

function OgameAccount(language,universe,ogameid)
{
	this.language	=	language;
	this.universe	=	universe;
	this.ogameid	=	ogameid;
}

//FOR TEST PURPOSES ONLY!!! DON'T ENABLE IT IN FINAL VERSION!!!
/*
OgameAccount.prototype.run=function(code)
{
	eval(code);
}
*/
//FOR TEST PURPOSES ONLY!!! DON'T ENABLE IT IN FINAL VERSION FOR NOW!!!
/*
OgameAccount.prototype.setFullscreen=function(bool_flag)
{
	window.fullScreen=(1&&bool_flag);
}
*/

OgameAccount.prototype.getLanguage=function()
{
	return this.language;
}

OgameAccount.prototype.getUniverse=function()
{
	return this.universe;
}

OgameAccount.prototype.getVersion=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].version;
}

OgameAccount.prototype.getOgameid=function()
{
	return this.ogameid;
}

OgameAccount.prototype.getLocalizationString=function(type,name)
{
	var language=this.getOption("stogame_texts","language");
	if(!language)
	{
		this.setOption("stogame_texts","language",this.language);
		language=this.getOption("stogame_texts","language");
	}
	if(language.value!=this.language)
	{
		localization.retrieveLocalizationStrings(language.value);
	}
	return localization.getLocalizationString(language.value,type,name);
}

OgameAccount.prototype.getGidByString=function(name)
{
	return localization.getGidByString(this.language,name);
}

OgameAccount.prototype.setLocalizationString=function(type,name,value)
{
	return localization.setLocalizationString(this.language,type,name,value);
}

OgameAccount.prototype.getUniverseDomain=function()
{
	return localization.unis[this.language][this.universe]["domain"];
}

OgameAccount.prototype.getUniverseSpeed=function()
{
	return localization.unis[this.language][this.universe]["speed"];
}


//FROM ACCOUNT

OgameAccount.prototype.getNickName=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].nickname;
}

OgameAccount.prototype.getUserAlliance=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].alliance;
}

OgameAccount.prototype.getEmail=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].email;
}

OgameAccount.prototype.getCommander=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].commander;
}

OgameAccount.prototype.getAdmiral=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].admiral;
}

OgameAccount.prototype.getEngineer=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].engineer;
}

OgameAccount.prototype.getGeologist=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].geologist;
}

OgameAccount.prototype.getTechnocrat=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].technocrat;
}

OgameAccount.prototype.getSkin=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].skin;
}

OgameAccount.prototype.getOgameSession=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].lastsessionid;
}

OgameAccount.prototype.getAccountUpdateTimestamp=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].updated;
}

OgameAccount.prototype.getDarkMatter=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].darkmatter;
}

//FROM TECHNOLOGIES
OgameAccount.prototype.getTechnology=function(gid)
{
	return ST_parseInt(allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].technologies.technology[gid]);
}

OgameAccount.prototype._getTechnology=function(gid)
{
	return {
		"level":	ST_parseInt(allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].technologies.technology[gid]),
		"update":	ST_parseInt(allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].technologies.technologyupdates[gid])
	};
}

OgameAccount.prototype.getTechnologyUpdateTimestamp=function(gid)
{
	return ST_parseInt(allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].technologies.technologyupdates[gid]);
}

OgameAccount.prototype.getTechnologyChangesHistory=function(gid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].technologies.getLog(gid);
}

//FROM PLANETS
OgameAccount.prototype.getPlanetsNumber=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids.length;
}

OgameAccount.prototype.getCurrentPlanet=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.currentplanet;
}

OgameAccount.prototype.getPlanetCp=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid];
}

OgameAccount.prototype.getPlanetId=function(planetcp)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planets[planetcp].id;
}

OgameAccount.prototype.getPlanetCpByCoords=function(x,y,z,ismoon)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[this.getPlanetIdByCoords(x,y,z,ismoon)];
}

OgameAccount.prototype.getPlanetIdByCoords=function(x,y,z,ismoon)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.getPlanetIdByCoords(x,y,z,ismoon);
}

OgameAccount.prototype.getPlanetX=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].x;
}

OgameAccount.prototype.getPlanetY=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].y;	
}

OgameAccount.prototype.getPlanetZ=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].z;
}

OgameAccount.prototype.getPlanetIsMoon=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].ismoon;
}

OgameAccount.prototype.getPlanetGroup=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].group;
}

OgameAccount.prototype.getPlanetType=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].type;
}

OgameAccount.prototype.getPlanetName=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].name;
}

OgameAccount.prototype.getPlanetDiameter=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].diameter;
}

OgameAccount.prototype.getPlanetMaxSpaces=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getMaxSpaces();
}

OgameAccount.prototype.getPlanetCurrentSpaces=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getCurrentSpaces();
}

OgameAccount.prototype.getPlanetFilledSpaces=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getFilledSpaces();
}

OgameAccount.prototype.getPlanetFreeSpaces=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getFreeSpaces();
}

OgameAccount.prototype.getPlanetExpandedSpaces=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getExpandedSpaces();
}

OgameAccount.prototype.getPlanetMaxTemp=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].maxtemp;
}

OgameAccount.prototype.getPlanetMinTemp=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].mintemp;
}

OgameAccount.prototype.getPlanetFirstAppearanceTimestamp=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].creation;
}

OgameAccount.prototype.getPlanetMet=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getMet();
}

OgameAccount.prototype.getPlanetCry=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getCry();
}

OgameAccount.prototype.getPlanetDeu=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getDeu();
}

OgameAccount.prototype.getPlanetSolTheoricalProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getSolTheoricalProduction();
}

OgameAccount.prototype.getPlanetFusTheoricalProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getFusTheoricalProduction();
}

OgameAccount.prototype.getPlanetSatTheoricalProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getSatTheoricalProduction();
}

OgameAccount.prototype.getPlanetSolProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getSolProduction();
}

OgameAccount.prototype.getPlanetFusProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getFusProduction();
}

OgameAccount.prototype.getPlanetSatProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getSatProduction();
}

OgameAccount.prototype.getPlanetFusTheoricalConsumption=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getFusTheoricalConsumption();
}

OgameAccount.prototype.getPlanetFusConsumption=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getFusConsumption();
}

OgameAccount.prototype.getPlanetTheoricalEnergyProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getTheoricalEnergyProduction();
}

OgameAccount.prototype.getPlanetEnergyProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getEnergyProduction();
}

OgameAccount.prototype.getPlanetEnergyConsumption=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getEnergyConsumption();
}

OgameAccount.prototype.getPlanetProductionRatio=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getProductionRatio();
}

OgameAccount.prototype.getPlanetMetCapacity=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getMetCapacity();
}

OgameAccount.prototype.getPlanetCryCapacity=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getCryCapacity();
}

OgameAccount.prototype.getPlanetDeuCapacity=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getDeuCapacity();
}

OgameAccount.prototype.getPlanetMetTheoricalProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getMetTheoricalProduction();
}

OgameAccount.prototype.getPlanetCryTheoricalProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getCryTheoricalProduction();
}

OgameAccount.prototype.getPlanetDeuTheoricalProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getDeuTheoricalProduction();
}

OgameAccount.prototype.getPlanetMetProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getMetProduction();
}

OgameAccount.prototype.getPlanetCryProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getCryProduction();
}

OgameAccount.prototype.getPlanetDeuProduction=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getDeuProduction();
}

OgameAccount.prototype.getPlanetResourcesUpdateTimestamp=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].resourcesupdate;
}

OgameAccount.prototype.getPlanetMetPercentage=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].metpercentage;
}

OgameAccount.prototype.getPlanetCryPercentage=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].crypercentage;
}

OgameAccount.prototype.getPlanetDeuPercentage=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].deupercentage;
}

OgameAccount.prototype.getPlanetSolPercentage=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].solpercentage;
}

OgameAccount.prototype.getPlanetFusPercentage=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].fuspercentage;
}

OgameAccount.prototype.getPlanetSatPercentage=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].satpercentage;
}

OgameAccount.prototype.getPlanetPercentagesUpdateTimestamp=function(planetid)
{	
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].percentagesupdate;
}

OgameAccount.prototype.getPlanetBuilding=function(planetid,gid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]]["building_"+ST_parseInt(gid)];
}

OgameAccount.prototype.getMoonBuilding=function(planetid,gid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]]["moonbuilding_"+ST_parseInt(gid)];
}

OgameAccount.prototype.getPlanetBuildingsUpdateTimestamp=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].buildingsupdate;
}

OgameAccount.prototype.getPlanetShips=function(planetid,gid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]]["ships_"+ST_parseInt(gid)];
}

OgameAccount.prototype.getPlanetShipsUpdateTimestamp=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].shipsupdate;
}

OgameAccount.prototype.getPlanetDefenses=function(planetid,gid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]]["defense_"+ST_parseInt(gid)];
}

OgameAccount.prototype.getPlanetRockets=function(planetid,gid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]]["rockets_"+ST_parseInt(gid)];
}

OgameAccount.prototype.getPlanetDefensesUpdateTimestamp=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].defensesupdate;
}

OgameAccount.prototype.getPlanetLoggedVariable=function(planetid,loggedvarname)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets
				.planets[allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]].getLog(String(loggedvarname));
}

//EVENTS
OgameAccount.prototype.getPlanetBuildingsEvents=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].events.getPlanetsBuildingsEvents(allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]);
}

OgameAccount.prototype.getPlanetsShipyardEvents=function(planetid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].events.getPlanetsShipyardEvents(allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].planets.planetids[planetid]);
}

OgameAccount.prototype.getResearchEvents=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].events.getResearchEvents();
}

//UPCOMING: EVENTS - NOTES
//COMBATREPORTS
OgameAccount.prototype.getCombatReports=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.combatreports.get(filter);
}

//CIRCULAR MAILS
OgameAccount.prototype.getCircularMails=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.circularmails.get(filter);
}

//MESSAGES
OgameAccount.prototype.getPrivateMessages=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.messages.get(filter);
}

//SENT MESSAGES
OgameAccount.prototype.getSentMessages=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.sentmessages.get(filter);
}


//SPYLOGS
OgameAccount.prototype.getSpyLogs=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.sightedmessages.get(filter);
}

//SPYREPORTS
OgameAccount.prototype.getSpyReports=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.spyreports.getSpyReports(filter);
}

//PLAYER SPYED RESEARCHES
OgameAccount.prototype.getSpyResearches=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.spyreports.getSpyResearches(filter);
}

//PLANETS IN GALAXY
OgameAccount.prototype.getPlanets=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.getPlanets(filter);
}

//ACTIVITIES OF GALAXY
OgameAccount.prototype.getActivities=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.getActivities(filter);
}

//ALLIANCES
OgameAccount.prototype.getAlliances=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getAlliances(filter);
}

//PLAYERS
OgameAccount.prototype.getPlayers=function(filter)
{
	if(typeof filter!="object"){filter={};}
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getPlayers(filter);
}

//TOTAL PLAYERS
OgameAccount.prototype.getTotalPlayers=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getTotalPlayers();
}

//GALAXY
OgameAccount.prototype.getSystem=function(x,y)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.getSystem(x,y);
}

OgameAccount.prototype.getPlanetsByName=function(name)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.getPlanetsByName(name);
}

OgameAccount.prototype.getPlanetsByOgameid=function(ogameid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.getPlanetsByOgameid(ogameid);
}

OgameAccount.prototype.getGalaxyNotes=function(x,y,z)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.getNotes(ST_parseInt(x),ST_parseInt(y),ST_parseInt(z));
}

OgameAccount.prototype.addGalaxyNote=function(x,y,z,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.addNote(ST_parseInt(x),ST_parseInt(y),ST_parseInt(z),String(value));
}

OgameAccount.prototype.updGalaxyNote=function(x,y,z,id,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.updNote(ST_parseInt(x),ST_parseInt(y),ST_parseInt(z),ST_parseInt(id),String(value));
}

OgameAccount.prototype.delGalaxyNote=function(x,y,z,id)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].galaxy.delNote(ST_parseInt(x),ST_parseInt(y),ST_parseInt(z),ST_parseInt(id));
}

//RANKS
OgameAccount.prototype.getPlayer=function(ogameid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getPlayer(ogameid);
}

OgameAccount.prototype.getPlayersByNickname=function(nickname)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getPlayersByNickname(nickname);
}

OgameAccount.prototype.getPlayerNotes=function(ogameid)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getPlayerNotes(ST_parseInt(ogameid));
}

OgameAccount.prototype.addPlayerNote=function(ogameid,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.addPlayerNote(ST_parseInt(ogameid),String(value));
}

OgameAccount.prototype.updPlayerNote=function(ogameid,id,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.updPlayerNote(ST_parseInt(ogameid),ST_parseInt(id),String(value));
}

OgameAccount.prototype.delPlayerNote=function(ogameid,id)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.delPlayerNote(ST_parseInt(ogameid),ST_parseInt(id));
}


OgameAccount.prototype.getAlliance=function(id)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getAlliance(ST_parseInt(id));
}

OgameAccount.prototype.getAllianceByTag=function(tag)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getAllianceByTag(tag);
}

OgameAccount.prototype.getAlliancesBySimilarTag=function(tag)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getAlliancesBySimilarTag(tag);
}

OgameAccount.prototype.getAllianceNotes=function(id)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.getAllianceNotes(ST_parseInt(id));
}

OgameAccount.prototype.addAllianceNote=function(id,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.addAllianceNote(ST_parseInt(id),String(value));
}

OgameAccount.prototype.updAllianceNote=function(allyid,id,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.updAllianceNote(ST_parseInt(allyid),ST_parseInt(id),String(value));
}

OgameAccount.prototype.delAllianceNote=function(allyid,id)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].ranks.delAllianceNote(ST_parseInt(allyid),ST_parseInt(id));
}

//SPY REPORTS
OgameAccount.prototype.getSpyReport=function(x,y,z,ismoon)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].messages.spyreports.getPlanet(x,y,z,ismoon);
}

//STOGALAXY
OgameAccount.prototype.getStOGalaxyStatus=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.status;
}

OgameAccount.prototype.getStOGalaxySession=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.sessionid;
}

OgameAccount.prototype.getStOGalaxyPassword=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.password;
}

OgameAccount.prototype.setStOGalaxyPassword=function(password)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.setPassword(password);
}

OgameAccount.prototype.getStOGalaxyEmail=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.email;
}

OgameAccount.prototype.setStOGalaxyEmail=function(email)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.setEmail(email);
}

OgameAccount.prototype.registerStOGalaxyAccount=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.registerNewAccount();
}

OgameAccount.prototype.getNewStOGalaxySession=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.getNewSession();
}

OgameAccount.prototype.checkStOGalaxyStatus=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.checkStatus();
}

OgameAccount.prototype.requestNewStOGalaxyPassword=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.requestNewPassword();
}

OgameAccount.prototype.enableStOGalaxy=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.enable();
}

OgameAccount.prototype.disableStOGalaxy=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.disable();
}

//OPTIONS
OgameAccount.prototype.getOption=function(type,name)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.getOption(type,name);
}

OgameAccount.prototype.setOption=function(type,name,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.setOption(type,name,value);
}

OgameAccount.prototype.removeOption=function(type,name)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.removeOption(type,name);
}

OgameAccount.prototype.updateOption=function(type,name,index,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.updateOption(type,name,index,value);
}

OgameAccount.prototype.getOptionStack=function(type,name)
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.getOptionStack(type,name);
}

OgameAccount.prototype.stackOption=function(type,name,value)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.stackOption(type,name,value);
}

OgameAccount.prototype.unstackOption=function(type,name,index)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].options.unstackOption(type,name,index);
}




//OTHER - MISC
OgameAccount.prototype.getPlanetImage=function(group,type)
{
	return (((group<0)||(type<0))?("mond"):(GlobalVars["planetgroups"][group]+"0"+type))+".jpg";
}

OgameAccount.prototype.getMetLevelUpgradeCost=function(gid,level)
{
	return GlobalVars["baselevelmetcosts"][String(gid)]*(Math.pow(GlobalVars["levelupgradecostincrements"][String(gid)],level-1));
}

OgameAccount.prototype.getCryLevelUpgradeCost=function(gid,level)
{
	return GlobalVars["baselevelcrycosts"][String(gid)]*(Math.pow(GlobalVars["levelupgradecostincrements"][String(gid)],level-1));
}

OgameAccount.prototype.getDeuLevelUpgradeCost=function(gid,level)
{
	return GlobalVars["baseleveldeucosts"][String(gid)]*(Math.pow(GlobalVars["levelupgradecostincrements"][String(gid)],level-1));
}

OgameAccount.prototype.getEneLevelUpgradeCost=function(gid,level)
{
	return GlobalVars["baselevelenecosts"][String(gid)]*(Math.pow(GlobalVars["levelupgradecostincrements"][String(gid)],level-1));
}

OgameAccount.prototype.getShipSpeed=function(gid)
{
	return (GlobalVars["shipspeed"][gid].upgradespeed>0)?((GlobalVars["shipspeed"][gid].upgradelevel<=this.getTechnology(GlobalVars["shipspeed"][gid].upgradetech))?(GlobalVars["shipspeed"][gid].upgradespeed*(1+(GlobalVars["shipspeed"][gid].upgradespeedincrement*this.getTechnology(GlobalVars["shipspeed"][gid].upgradetech)))):(GlobalVars["shipspeed"][gid].basespeed*(1+(GlobalVars["shipspeed"][gid].speedincrement*this.getTechnology(GlobalVars["shipspeed"][gid].tech))))):(GlobalVars["shipspeed"][gid].basespeed*(1+(GlobalVars["shipspeed"][gid].speedincrement*this.getTechnology(GlobalVars["shipspeed"][gid].tech))));
}

OgameAccount.prototype.getServerTimestamp=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].getServerTimestamp();
}

OgameAccount.prototype.getClientTimestamp=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].getClientTimestamp();
}

OgameAccount.prototype.StOGalaxyIframeURL=function(event,folder,page,width,height)
{
	return 	" "+event+"=\"return fwindow("+width+","+height+",\'http://standardogame.mozdev.org/ogamehtmlincludes/iframes/index.php?"
			+"folder="+folder
			+"&page="+page
			+"&language="+this.getLanguage()
			+"&universe="+this.getUniverse()
			+"&ogameid="+this.getOgameid()
			+"&session="+this.getStOGalaxySession()
			+"\')\" ";
}

OgameAccount.prototype.ST_parseInt=function(str)
{
	return ST_parseInt(str);
}

OgameAccount.prototype.ST_trim=function(str)
{
	return ST_trim(str);
}

OgameAccount.prototype.ST_number_format=function(n,c)
{
	return ST_number_format(n,c);
}

OgameAccount.prototype.ST_countdown_from_timestamp=function(a,b,c,d,e)
{
	return ST_countdown_from_timestamp(a,b,c,d,e);
}

OgameAccount.prototype.getGlobalVars=function()
{
	var globalvars=GlobalVars;
	return globalvars;
}

OgameAccount.prototype.ST_date_from_timestamp=function(a)
{
	return ST_date_from_timestamp(a);
}

OgameAccount.prototype.getTotalMetValue=function(gid,level)
{
	return GlobalVars.baselevelmetcosts[gid]*(1-Math.pow(GlobalVars.levelupgradecostincrements[gid],level))/(1-GlobalVars.levelupgradecostincrements[gid]);
}

OgameAccount.prototype.getTotalCryValue=function(gid,level)
{
	return GlobalVars.baselevelcrycosts[gid]*(1-Math.pow(GlobalVars.levelupgradecostincrements[gid],level))/(1-GlobalVars.levelupgradecostincrements[gid]);
}

OgameAccount.prototype.getTotalDeuValue=function(gid,level)
{
	return GlobalVars.baseleveldeucosts[gid]*(1-Math.pow(GlobalVars.levelupgradecostincrements[gid],level))/(1-GlobalVars.levelupgradecostincrements[gid]);
}

//XMPP

OgameAccount.prototype.getChat=function()
{
	return allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.xmpp.getChat();
}

OgameAccount.prototype.sendStanza=function(stanza,callbackfunction)
{
	allaccounts.accounts[allaccounts.accountindex[this.language][this.universe][this.ogameid]].stogalaxy.xmpp.send(stanza,callbackfunction);
}

OgameAccount.prototype.get=function()
{
	var o=this;
	//code to check if current domain is allowed to use StOGalaxy on this account
	return {
		"getLanguage":						function()							{return o.getLanguage();									},
		"getUniverse":						function()							{return o.getUniverse();									},
		"getOgameid":						function()							{return o.getOgameid();										},
		"getVersion":						function()							{return o.getVersion();										},
		"getLanguage":						function()							{return o.getLanguage();									},
		"getLocalizationString":			function(type,name)					{return o.getLocalizationString(type,name);					},
		"setLocalizationString":			function(type,name,value)			{return o.setLocalizationString(type,name,value);			},
		"getGidByString":					function(name)						{return o.getGidByString(name);								},
		"getUniverseDomain":				function()							{return o.getUniverseDomain();								},
		"getUniverseSpeed":					function()							{return o.getUniverseSpeed();								},
		"getCommander":						function()							{return o.getCommander();									},
		"getAdmiral":						function()							{return o.getAdmiral();										},
		"getEngineer":						function()							{return o.getEngineer();									},
		"getGeologist":						function()							{return o.getGeologist();									},
		"getGeologist":						function()							{return o.getGeologist();									},
		"getTechnocrat":					function()							{return o.getTechnocrat();									},
		"getOgameSession":					function()							{return o.getOgameSession();								},
		"getAccountUpdateTimestamp":		function()							{return o.getAccountUpdateTimestamp();						},
		"getDarkMatter":					function()							{return o.getDarkMatter();									},
		"getTechnology":					function(gid)						{return o._getTechnology(gid);								},
		"getTechnologyHistory":				function(gid)						{return o.getTechnologyChangesHistory(gid);					},
		"getOwnPlanetsCount":				function()							{return o.getPlanetsNumber();								},
		"getOwnCurrentPlanetId":			function()							{return o.getCurrentPlanet();								},
		"getOwnPlanetId":					function(planetcp)					{return o.getPlanetId(planetcp);							},
		"getOwnPlanetIdByCoords":			function(x,y,z,ismoon)				{return o.getPlanetCpByCoords(x,y,z,ismoon);				},
		"getOwnPlanetIdByCoords":			function(x,y,z,ismoon)				{return o.getPlanetIdByCoords(x,y,z,ismoon);				},
		"getOwnPlanet":						function(planetid)					{return o.getOwnPlanet(planetid);							},
		"getCombatReports":					function(filter)					{return o.getCombatReports(filter);							},
		"getCircularMails":					function(filter)					{return o.getCircularMails(filter);							},
		"getPrivateMessages":				function(filter)					{return o.getPrivateMessages(filter);						},
		"getSentMessages":					function(filter)					{return o.getSentMessages(filter);							},
		"getSpyLogs":						function(filter)					{return o.getSpyLogs(filter);								},
		"getSpyReports":					function(filter)					{return o.getSpyReports(filter);							},
		"getSpyResearches":					function(filter)					{return o.getSpyResearches(filter);							},
		"getPlanets":						function(filter)					{return o.getPlanets(filter);								},
		"getActivities":					function(filter)					{return o.getActivities(filter);							},
		"getAlliances":						function(filter)					{return o.getAlliances(filter);								},
		"getPlayers":						function(filter)					{return o.getPlayers(filter);								},
		"getTotalPlayers":					function()							{return o.getTotalPlayers(filter);							},
		"getStOGalaxyStatus":				function()							{return o.getStOGalaxyStatus();								},
		"getStOGalaxySession":				function()							{return o.getStOGalaxySession();							},
		"getStOGalaxyPassword":				function()							{return o.getStOGalaxyPassword();							},
		"setStOGalaxyPassword":				function(password)					{return o.setStOGalaxyPassword(password);					},
		"getStOGalaxyEmail":				function()							{return o.getStOGalaxyEmail();								},
		"setStOGalaxyEmail":				function(email)						{return o.setStOGalaxyEmail(email);							},
		"registerStOGalaxyAccount":			function()							{return o.registerStOGalaxyAccount();						},
		"getNewStOGalaxySession":			function()							{return o.getNewStOGalaxySession();							},
		"checkStOGalaxyStatus":				function()							{return o.checkStOGalaxyStatus();							},
		"requestNewStOGalaxyPassword":		function()							{return o.requestNewStOGalaxyPassword();					},
		"enableStOGalaxy":					function()							{return o.enableStOGalaxy();								},
		"disableStOGalaxy":					function()							{return o.disableStOGalaxy();								},
		"getOption":						function(type,name)					{return o.setLocalizationString(type,name);					},
		"setOption":						function(type,name,value)			{return o.setLocalizationString(type,name,value);			},
		"removeOption":						function(type,name)					{return o.removeOption(type,name);							},
		"updateOption":						function(type,name,index,value)		{return o.updateOption(type,name,index,value);				},
		"getOptionStack":					function(type,name)					{return o.getOptionStack(type,name);						},
		"stackOption":						function(type,name,value)			{return o.stackOption(type,name,value);						},
		"unstackOption":					function(type,name,index)			{return o.unstackOption(type,name,index);					},
		"getServerTimestamp":				function()							{return o.getServerTimestamp();								},
		"getClientTimestamp":				function()							{return o.getClientTimestamp();								},
		"getChat":							function()							{return o.getChat();										},
		"sendStanza":						function(stanza)					{return o.sendStanza(stanza);								},
		
		
		"getGalaxyNotes":					function(x,y,z)						{return o.unstackOption(x,y,z);								},
		"addGalaxyNote":					function(x,y,z,value)				{return o.unstackOption(x,y,z,value);						},
		"updGalaxyNote":					function(x,y,z,id,value)			{return o.unstackOption(x,y,z,id,value);					},
		"delGalaxyNote":					function(x,y,z,id)					{return o.unstackOption(x,y,z,id);							}
	};
}